%{
// Simple parser for sample calculator

#include <iostream>
using namespace std;

// Declare some functions so g++ won't complain
extern void yyerror ( char * );
extern int yylex ( void );

%}

// Declare all possible attribute types. There is only one in
// this application, of type "int".
%union
{
	int intval;
}

// Declare attribute type = int for tokens and nonterminals
%token <intval> INTEGER
%type <intval> expression term factor

%%
program:	linelist ';'
			{
				cout << "Successful Completion" << endl;
			}
		;

linelist:	linelist ';'
			{
				cout << endl;
			}
		|
			expression
			{
				cout << $1 << endl;
			}
		|
			linelist ';' expression
			{
				cout << $3 << endl;
			}
		;

expression:	expression '+' term
			{
				$$ = $1 + $3;
			}

		|	expression '-' term
			{
				$$ = $1 - $3;
			}
		|	term
		;

term	:	term '*' factor
			{
				$$ = $1 * $3;
			}
		|
			term '/' factor
			{
				$$ = $1 * $3;
			}
		|
			factor
		;
factor	:	INTEGER
		|
			'(' expression ')'
			{
				$$ = $2;
			}
		;

%%

// Do something with bison-generated error messages
void yyerror ( char *msg )
{
	cout << "bison: " << msg << endl;
}
